## stella 6.7.1+dfsg

=== debian/changelog ===
stella (6.7.1+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:04:16 +1100

stella (6.7.1+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:17:05 +0000

stella (6.7.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update Lintian override syntax.

 -- Stephen Kitt <skitt@debian.org>  Thu, 18 Jan 2024 16:29:41 +0100
