=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%stella-$1.tar.gz%" \
    https://github.com/stella-emu/stella/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
