=== debian/changelog ===
stella (7.0+dfsg-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Add cross.patch prepending _host_prefix to pkg-config.
    Closes: #1094710.

  [ Stephen Kitt ]
  * debian/rules: switch to execute_after/before.

 -- Stephen Kitt <skitt@debian.org>  Fri, 31 Jan 2025 08:32:49 +0100

stella (7.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Enable parallel linking with LTO.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 06 Oct 2024 15:48:32 +0200
